/**
 * AmbientTalk/2 Project
 * ATTabulation.java created on 26-jul-2006 at 15:09:25
 * (c) Programming Technology Lab, 2006 - 2007
 * Authors: Tom Van Cutsem & Stijn Mostinckx
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
package edu.vub.at.objects.grammar;

/**
 * The public interface to a tabulation AG element.
 * 
 * Example: <code>tab[idx]</code>
 * 
 * @author tvc
 */
public interface ATTabulation extends ATExpression {

	/**
	 * The table expression must evaluate to a native table
	 * Example: <code>`(m()[idx+1]).tableExpression == `(m())</code>
	 * @return the table expression
	 */
	public ATExpression base_tableExpression();
	
	/**
	 * The index expression must evaluate to a native number
	 * Example: <code>`(m()[idx+1]).indexExpression == `(idx.+(1))</code>
	 * @return the index expression
	 */
	public ATExpression base_indexExpression();
	
}
